# signature { license=0, seed=457995617, key="19e334c6f1e6313bca8c5e2fa1a9a93e" }
--




if not CGI then return end

require 'socket'

if CGI.sslsocket then require 'ssl' end

local cgi = CGI
local sock = cgi.socket
local closed = false
local tostring,concat,format,char,gsub = tostring,table.concat,string.format,string.char,string.gsub

cgi._VERSION = 'cgi 1.5.1'

cgi.reset = function()
	cgi.status = '200 OK'
	cgi.headers = { ['Content-Type'] = 'text/html; charset=UTF-8'; ['Connection']='close';}
	cgi.content = {}
	closed = false
end

cgi.header = function( name, value)
	CGI.headers[ name ] = tostring(value or '')
end

cgi.print = function(...)
	local args = { ... }
	for i = 1, select('#',...) do
		args[i] = tostring(args[i])
	end
	local s = table.concat(args)
	cgi.content[1+#cgi.content] = s
	return s
end

cgi.printf = function( formatstring, ... )
	return cgi.print( format( formatstring, ...))
end




cgi.close = function() closed = true end




cgi.flush = function()
	if closed then return end
	local H = concat( cgi.content )
	cgi.header( 'Content-Length', #H)	

	sock:send( format( 'HTTP/1.1 %s\r\n', cgi.status))
	for k,v in pairs( cgi.headers ) do
		sock:send( format( '%s: %s\r\n', k, v))
	end
	sock:send( '\r\n')
	sock:send( H)
end

cgi.commit = function()
	cgi.flush()
	cgi.reset()


	for k in next, cgi do
		if string.find( k, '^%u') then cgi[k] = nil end
	end
end

cgi.send   = function(...) return sock:send(...)    end
cgi.receive= function(...) return sock:receive(...) end




cgi.begin = function()


	if not cgi.REQUEST_METHOD then

		local s = sock:receive()   
		if not s then return end

		cgi.REQUEST_METHOD, cgi.REQUEST_URI, cgi.QUERY_STRING = s:match("^(%u+) ([^?]*)%??(%S*) ")
	end
	

	repeat
		local s = sock:receive()
		if not s then break end
	

		local k,v = string.match( s,'^(.-):%s*(.*)$')
		if k then
			k = gsub( string.upper(k), '[-]', '_')
			cgi[k] = v
		end
	until s==''
	

	cgi.reset()
	return true
end

local function unescape(s)  
    return gsub( s, '%%(%x%x)', function(hex) return char(tonumber(hex, 16)) end )
end
cgi.unescape = unescape

cgi.urldecode = function( s )
	local T = {}
	s = gsub( s, '+', ' ' )
	gsub( s, '([^=]+)=([^&]*)&?', function(k,v) T[ unescape(k) ] = unescape(v) end )
	return T
end




cgi.begin()           




return setmetatable( cgi, {__gc = cgi.flush })

