# signature { license=0, seed=457995617, key="f57f0782dff7873292c23e2ab57a584f" }
--






local copas = require("copas")
local pack = table.pack or function(...) return {n=select('#',...),...} end
local unpack = function(t) return (table.unpack or unpack)(t, 1, t.n or #t) end




local function add(self, task, ...)
	local carg = pack(...)
	local coro = copas.addthread(function()
			copas.sleep(-1)							-- go to sleep until being woken
			local suc, err = pcall(task, unpack(carg)) -- start the task
			self:removethread(coroutine.running())		   -- dismiss ourselves
			if not suc then error(err) end			 -- rethrow error
		end)
	table.insert(self.queue, coro)				 -- store in list
	self:next()
	return coro
end




local function remove(self, coro)
	self.queue[coro] = nil
	if self.running[coro] then

		self.running[coro] = nil
		self.count = self.count - 1
	else

		for i, item in ipairs(self.queue) do
			if coro == item then 
				table.remove(self.queue, i)
				break
			end
		end	
	end  
	self:next()
end


local function nxt(self)
	while self.count < self.maxt do
		local coro = self.queue[1]
		if not coro then break end -- queue is empty, so nothing to add

		table.remove(self.queue, 1)
		self.running[coro] = coro
		self.count = self.count + 1
		copas.wakeup(coro)
	end
	if self.count == 0 and next(self.waiting) then

		for coro in pairs(self.waiting) do
			copas.wakeup(coro)
		end
	end
end


local function wait(self)
	if self.count == 0 then return end  -- There's nothing to do...
	local coro = coroutine.running()

	self.waiting[coro] = true
	copas.sleep(-1)
	self.waiting[coro] = nil
end


local function new(maxt)
	return {
		maxt = maxt or 99999,   -- max simultaneous tasks
		count = 0,              -- count of running tasks
		queue = {},             -- tasks waiting (list/array)
		running = {},           -- tasks currently running (indexed by coroutine)
		waiting = {},           -- coroutines, waiting for all tasks being finished (indexed by coro)
		addthread = add,
		removethread = remove,
		next = nxt,
		wait = wait,
	}
end

return { new = new }

