# signature { license=0, seed=457995617, key="3827b6ab153f788448997463fec93cd6" }
local md5 = require("md5")
local exor,rep = md5.exor, string.rep

local function hmac(key, text, hash, hex)
	assert( type(key)  == 'string', "key must be a string")
	assert( type(text) == 'string', "text must be a string")
	hash = hash or md5
	if #key > hash.BLOCK_SIZE then key = hash(key) end
	key = key .. rep("\0", hash.BLOCK_SIZE - #key)
	return hash( exor(key,"\x5c") .. hash(exor(key,"\x36") .. text), hex)
end

return setmetatable
(
	{
		_VERSION = "hmac 1.0.3";
		hmac     = hmac;
	} ,
	{
		__call = function( _, ... ) 
				return  hmac( ... ) 
			end 
	}
)

