# signature { license=0, seed=457995617, key="6749f6761a2b8f043b04eebafacf4439" }
local md5 = require'md5.core'
local gsub, format, byte = string.gsub, string.format, string.byte 

md5.BLOCK_SIZE = 64
md5._VERSION = "md5 1.0.4"

function md5.hex( k )
  return ( gsub( k, '.', function (c)
           return format('%02x', byte(c))
         end))
end

function md5.md5( msg, hex )
	local sum = md5.sum( msg )
	if hex then return md5.hex( sum ) end
	return sum
end

return setmetatable
(
	md5, 
	{
		__call = function( _, msg, hex ) return md5.md5( msg, hex ) end 
	}
)

